<?php
/*
  $Id: contrib_tracker.php,v 1.7.15 2009/05/24 17:33:32 SteveDallas Exp $

  2009 May 24 v1.7.15 Glen Hoag aka SteveDallas Fixed detection/creation of local cache file for servers where DIR_FS_CATALOG != DIR_WS_CATALOG
                                                Made the HTML output compliant with the HTML 4.01 DTD
                                                Cleaned up the email notification option.  


  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  Copyright (c) 2003 osCommerce

  Released under the GNU General Public License
_________________________________________________________________

Contribution Tracker MODULE for osC Admin
By Admin of www.silvermoon-jewelry.com
Based on:
		Admin_notes: Original Code By: Robert Hellemans of www.RuddlesMills.com
		RSS News for OSC
These are LIVE SHOPS - So please, no TEST accounts etc...
We will report you to your ISP if you abuse our websites!
*/

require('includes/application_top.php');
require(DIR_WS_CLASSES . 'rdf_class.php');
require(DIR_WS_FUNCTIONS . 'contrib_tracker.php');
$xmlURL='http://feedproxy.feedburner.com/osCommerce_Contributions';
$format = '%Y-%m-%d %H:%M:%S';

// Install a configuration key to determine whether to send email reports to store owner.  
// Set it to 'false'. (Can be changed in admin Config->E-Mail.)

if (CONTRIB_TRACKER_NOTIFICATION == 'CONTRIB_TRACKER_NOTIFICATION') {
  tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added, set_function) values ('Contrib Tracker Notification email', 'CONTRIB_TRACKER_NOTIFICATION', 'false', 'Send Contrib Tracker notifications to store owner', '12', '4815', now(), 'tep_cfg_select_option(array(\'true\', \'false\'),')");   
}

// Make the output minimal valid HTML
?>
<!doctype html public "-//W3C//DTD HTML 4.01 Transitional//EN">
<html <?php echo HTML_PARAMS; ?>>
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=<?php echo CHARSET; ?>">
    <title><?php echo TITLE; ?></title>
  </head>
  <body>
<?php

if (extension_loaded('curl') == 1 && file_exists(DIR_FS_CATALOG . 'rsscache/contrib_rss.html')){
  vWritePageToFile($xmlURL, DIR_FS_CATALOG. 'rsscache/contrib_rss.html');
  $channel = new rdfFile(DIR_FS_CATALOG. 'rsscache/contrib_rss.html'); //rss cached file path
} else {
  $channel = new rdfFile($xmlURL); //rss file path
}

$channel->parse(True);
$countme=0;
$countme1=0;
while ($countme < $channel->ItemsCounter) {
			$thelink = $channel->Items[$countme]["Link"];
			$thetitle = $channel->Items[$countme]["Title"];
			$thedescription = $channel->Items[$countme]["Description"];
			$thepubdate = $channel->Items[$countme]["PubDate"];
			$pubtimestamp=strtotime($thepubdate);
			$pubtimestamp=strftime ($format, $pubtimestamp);

  // add backslashes to characters that need escaping
			$thetitle=addslashes($thetitle);

  // get database contributions with the name of the current item and last modded in store is less that the pubdate
  tep_db_query("UPDATE " . TABLE_CONTRIB_TRACKER . " SET status ='0', contr_last_modified = '" . $pubtimestamp . "'  where contrib_name = '" . $thetitle . "' and last_update < '" . $pubtimestamp . "'");

  $admin_query_query_raw = "select contr_id, contrib_name, contrib_link, status, note_created , contr_last_modified  last_update,config_comments, contrib_vers from " . TABLE_CONTRIB_TRACKER . " where contrib_name = '" . $thetitle . "' and last_update < '" . $pubtimestamp . "'";

  $admin_query_query = tep_db_query($admin_query_query_raw);            
		  
  if (tep_db_num_rows($admin_query_query) <> 0) {
    $countme1++;
    echo $thetitle . "<br>\n";
  }
  $countme++;
}

//send an email if any contribs need updating.
if ($countme1 > 0 && CONTRIB_TRACKER_NOTIFICATION == 'true') {
  $error = false;
  $name = "Contrib Tracker";
  $subject = "Contrib Tracker Summary";
  $enquiry = $countme . " contributions have been checked and " . $countme1 . " need updating.";
  if (tep_validate_email(STORE_OWNER_EMAIL_ADDRESS)) {
    tep_mail(STORE_OWNER, STORE_OWNER_EMAIL_ADDRESS, $subject, $enquiry, $name, STORE_OWNER_EMAIL_ADDRESS);
  }
  if (extension_loaded('curl')== 1 && file_exists(DIR_FS_CATALOG. 'rsscache/contrib_rss.html')){
    unlink(DIR_FS_CATALOG. 'rsscache/contrib_rss.html');
  }
}
echo "success\n";
?>
  </body>
</html>
